/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
#ifndef C_MODEL_H
#define C_MODEL_H

#ifndef CONFIG_DEFAULT_H
#define CONFIG_DEFAULT_H

/*This is generated by Sony/Sony_common_pcb_drv_cust.h*/
#ifndef SONY_COMMON_PCB_DRV_CUST_H
#define SONY_COMMON_PCB_DRV_CUST_H 1

//----------------------------------------------------------------------------
// Initial dram settings
//----------------------------------------------------------------------------
#ifdef DDR_BUS_X16_SUPPORT
	#define DEFAULT_DRAM_TYPE                   DDR_III_x1
#else
	#define DEFAULT_DRAM_TYPE                   DDR_III_x2
#endif
//#define DEFAULT_DDR_CLOCK                   (1404000000)
#define DEFAULT_DDR_CLOCK                   (1596000000)

#ifndef DEMO_BOARD
#define LEMUR_PLUS_4L_BOARD  // For Dram 2L & 4L Setting
#endif

//----------------------------------------------------------------------------
// Dram size configuration
//----------------------------------------------------------------------------
#ifdef CC_FORCE_DRAM256M
#ifndef CC_FORCE_JTV_DRAM512M
#define DEFAULT_CHANNEL_A_SIZE                  (256 * 1024 * 1024)
#define TOTAL_MEM_SIZE                          (256 * 1024 * 1024)
#else
#define DEFAULT_CHANNEL_A_SIZE                  (512 * 1024 * 1024)
#define TOTAL_MEM_SIZE                          (512 * 1024 * 1024)
#endif
#else
	#ifdef CC_FORCE_DRAM1024M
		#define DEFAULT_CHANNEL_A_SIZE			(1024 * 1024 * 1024)
		#define TOTAL_MEM_SIZE                  (1024 * 1024 * 1024)
	#else
		#ifdef CC_FORCE_DRAM512M
			#define DEFAULT_CHANNEL_A_SIZE		(512 * 1024 * 1024)
			#define TOTAL_MEM_SIZE              (512 * 1024 * 1024)
		#else
			#define DEFAULT_CHANNEL_A_SIZE		(768 * 1024 * 1024)
			#define TOTAL_MEM_SIZE              (768 * 1024 * 1024)
		#endif
	#endif
#endif

//#ifndef DRAM_PRIORITY_LIST
// Audio/0 > B2R/5 > NR/PSCAN/4 > Scpip/7 > OSD/3 > Mjc_in/13 > Mjc_out/14 > VLD1/9 > Vdec_mc/8 > CPU/6 > Gfx/11 > Demux/PVR/1 > VBI/3D/TVE/2 >VENC/12 > Test/15 > Unused/10
//#define DRAM_PRIORITY_LIST                  ((UINT8*)"0c9421a387fbd56e")
//#endif

#define DRVCUST_EEPROM_DATA_MEM_OFFSET ((UINT32)0x2F00000)  

#include              "Sony/sony_eeprom_layout.h"

#ifndef CUSTOM_OPTION_QUERY_FILE
#define CUSTOM_OPTION_QUERY_FILE                    "Sony/Sony_optionbit_query.h"
#endif
//----------------------------------------------------------------------------
// FBM setup
//----------------------------------------------------------------------------
//enlarge FBM due to change osd color mode from 4444 to 888 CL:2137900 
#ifndef CC_FORCE_DRAM256M
#ifndef CC_CONFIG_OSD_PLANE2_MAX_W
#define CC_CONFIG_OSD_PLANE2_MAX_W          (1366)
#endif
#ifndef CC_CONFIG_OSD_PLANE2_MAX_H
#define CC_CONFIG_OSD_PLANE2_MAX_H          (768)
#endif
#endif
//----------------------------------------------------------------------------
// Default Panel setting
//----------------------------------------------------------------------------
#ifndef DEFAULT_PANEL_SELECT
#define DEFAULT_PANEL_SELECT                (PANEL_DEFAULT)
#endif
//BL_ON
#define BACKLIGHT_GPIO                      (GPIO(73))//PIN_TCON7
#define BACKLIGHT_ON_VAL                    (1)
//PANEL_PWR
#define PANELPOWER_GPIO                     (GPIO(67))//PIN_TCON1
#define PANELPOWER_ON_VAL                   (1)

// disable spread spectrum for vga output
#define SPREAD_SPECTRUM_PERMILLAGE          (0)

// pwm backlight adjustment setting
#define PANEL_BACKLIGHT_PWM_PORT            (1)//srcpwm1->PWM_OPWM0

#define PDWNC_POLARITY                      (0)

//----------------------------------------------------------------------------
// Suspend power control GPIO Number, it must be PDWNC GPIO
//----------------------------------------------------------------------------
#define  SUSPEND_GPIO_NUMBER   	(0xFFFFFFFF) //DDR power control.//In FY17 DDR power control by PMIC
#define  SUSPEND_GPIO_POL   	(1) //0:active low,1:active high.


#ifndef DRV_LOGO_ENABLE
#define DRV_LOGO_ENABLE                         (1)
#endif
#define DRV_LOGO_H_FILE                         "Sony/sony_DrvLogo.h"
#define LOADER_MUSIC_H_FILE                     "Sony/sony_DrvLogoMusic.h"
#define DRV_LOGO_EARLY_RETURN_COUNTER          (0x6)

//----------------------------------------------------------------------------
// Audio Customization
//----------------------------------------------------------------------------
//audio
//-----------------------------------------------------------------------------
// AUDIO_Amp_Gpio_Num:         AMP mute
// AUDIO_Amp1_Gpio_Num:       Assist AMP mute (PAA/PAD)
// AUDIO_CUST_HP_GPIO_CTRL:    HP mute (HP/LINEOUT share HW port)
// AUDIO_CUST_SPEC_GPIO_CTRL:  SCART mute (EU)
// AUDIO_CUST_SPEC2_GPIO_CTRL: Hotel Bath SPK mute (PAD) 
//-----------------------------------------------------------------------------
#define AUDIO_INCLUDE_FILE                  "Sony/Sony_aud.h"

//X_AUDIO_MUTE1
#define AUDIO_Amp_Gpio_Num                  68//TCON2
#define AUDIO_AMP_GPIO_POLARITY             AUD_AMP_GPIO_HIGH_ENALBE //High:Unmute Low:Mute

//X_AUDIO_MUTE2
#define AUDIO_CUST_HP_GPIO_CTRL             71//TCON5 
#define AUDIO_CUST_HP_POLARITY              AUD_GPIO_HIGH_ENALBE    //High:Unmute Low:Mute

//X_AUDIO_RST
#define AUDIO_DIGITAL_AMP_RESET_GPIO            74//TCON8 
#define AUDIO_DIGITAL_AMP_RESET_GPIO_POLARITY   AUD_GPIO_HIGH_ENALBE   //AMP RST High: Normal Low:Mute

//HP_OP_DET
#define AUDIO_HP_PLUG_IN_GPIO               75//TCON9
#define AUDIO_HP_PLUG_IN_POLARITY           AUD_GPIO_LOW_ENALBE   //Low: HP Plug in    High:Optical Plug in

//CON_DET
#define AUDIO_HP_OP_PLUG_IN_GPIO               60//SD_CMD
#define AUDIO_HP_OP_PLUG_IN_POLARITY           AUD_GPIO_LOW_ENALBE   //Low: Plug in

//X_AUDIO_MUTE3
#define AUDIO_CUST_SPEC_GPIO_CTRL           61//SD_CLK
#define AUDIO_CUST_SPEC_POLARITY            AUD_GPIO_HIGH_ENALBE   //Hihg:Unmute Low:Mute
//#define AUDIO_INPUT_MUX_SEL_TABLE           (&_rMustangAudInputMuxTable)

#define AUDIO_SPK_TYPE_LARGE                (FALSE)

#ifdef CC_AUD_PAA_SUPPORT
#define AUDIO_SUBWOOFER_ON                  (TRUE)
#else
#define AUDIO_SUBWOOFER_ON                  (FALSE)
#endif

#define AUDIO_DOWNMIX_WITH_BALANCE          (FALSE)

#define AUDIO_OUT_PAD_DRV_CUR               (2)

#define AUDIO_AOUT_PAD_CFG                  (&_arSonyAoutPadTable)
#define AUDIO_INPUT_MUX_SEL_TABLE           (&_rSonyAudInputMuxTable)
#define AUDIO_ADAC_USAGE                    (&_arSonyAdacUsage)
#define AUDIO_OUT_FMT_TABLE                 (&_arSonyAudOutFmtTable)
#define AUDIO_Digital_Data_TABLE            (&_afgSonyAudDigitalDataUsage)
#define AUDIO_INTER_DAC_USAGE               (&_arSonyInterDacUsage)
#define AUDIO_INPUT_SW_GPIO_SEL             (&_arSonyInputSwGpio)
#define AUDIO_INTER_DAC_USAGE_ES2           (&_arSonyInterDacUsage)

#define AUDIO_INPUT_SRC_VOL                 (&_aai2SonyAudInputSrcVol)
#define AUDIO_AV_INPUT_SRC_VOL              (&_ai2SonyAudAvInputSrcVol) 
#define AUDIO_VOL_TABLE                     (&_au4Sony_VolumeTable) 
#define AUDIO_CHANNEL_VOL_TABLE             (&_au4Sony_VolumeTable)
#define AUDIO_HEADPHONE_VOL_TABLE           (&_au4Sony_VolumeTable)
#define AUDIO_CHL_VOL_EXTRA_GAIN            (&_aai1SonyAudChVolExtraGain)
#define AUDIO_POWER_ON_MUSIC_VOL            (20)
#define AUDIO_IEC_COPYRIGHT                 (&_au1SonyAudIecCopyright)
#define AUD_CHL_SOUND_MODE_CFG              (&_arSonySoundModeCase)
#define AUDIO_AVC_TARGET_LEV                (&_ai2SonyAudAvcTarget)
#define AUDIO_AVC_GAIN_UP                   (&_ai2SonyAudAvcGainUp)

#ifdef CC_AUD_USE_FLASH_AQ
#ifdef CC_SONY_2K14_FLASH_AQ
#define AUDIO_FLASH_AQ_DATA_DSCRPT          (&_arSonyAudNvmDscrpt)
#define AUDIO_FLASH_AQ_DATA_DSCRPT_SIZE     (u1SonyAudAQDscrptSize)
#else ///def CC_SONY_2K15_FLASH_AQ
#define AUDIO_FLASH_AQ_DATA_DSCRPT          (&_arSonyAudSysNvmDscrpt)
#define AUDIO_FLASH_AQ_DATA_DSCRPT_SIZE     (u1SonyAudSysAQDscrptSize)
#define AUDIO_FLASH_AQ_DATA_DSCRPT1         (&_arSonyAudTuningNvmDscrpt)
#define AUDIO_FLASH_AQ_DATA_DSCRPT_SIZE1    (u1ISonyAudTuningAQDscrptSize)
#endif
#endif
#ifndef CC_MTK_LOADER
#define FLASH_AQ_BASE_PARTITION_A               (21)   //bank A;  bank B= bank A +1
#define FLASH_AQ_BASE_PARTITION                 (((DRVCUST_GetDTVCfg() & DTVCFG_FLAG3_ROOTFS_BANK)==DTVCFG_FLAG3_ROOTFS_BANK)?(FLASH_AQ_BASE_PARTITION_A+1):(FLASH_AQ_BASE_PARTITION_A))
#endif 
#define AUDIO_BI2S_ENABLE                   (FALSE)
#define AUDIO_MTS_FACTORY_MODE              (&_arSonyMtsFactory)
#define AUDIO_A2_FACTORY_MODE               (&_arSonyA2Factory)
#define AUDIO_PAL_FACTORY_MODE              (&_arSonyPalFactory)
#define AUDIO_SPDIF_ENABLE                  (FALSE)
#define AUDIO_DOWNMIX_CHANNEL_POSITION      (DOWNMIX_CH_BEFORE_AVC) 
#define AUDIO_MTK_VS_CLARITY                (0x200000)
#define AUDIO_MTK_VS_WIDTH                  (0x300000)
#define AUDIO_MTK_VS_XTALK                  (0x022000)
#define AUDIO_MTK_VS_OUTPUTGAIN             (0x043000)
#define AUDIO_MTK_VS_BASSGAIN               (0x060000)
#define AUDIO_LINE_OUT_FIX_VOL              (88)

#define AUDIO_HEAAC_MULTICHL_DDCO           (FALSE)
#define AUDIO_APROC_ENABLE                  (TRUE)
#define AUD_FLASH_AQ_FILE                       "Sony/unicorn_aud_flash_aq.c" //CC_AUD_AQ_IN_DRVCUST

//----------------------------------------------------------------------------
// Other GPIO customization
//#define DEFAULT_TUNER_RFAGC_SWITCH_GPIO     (85)//d120203_Haibo:OPWM2 is for RFAGC switch

//----------------------------------------------------------------------------
#define FLAG_EXT_STATUS                     (1)
//#define POWER_LED_GPIO                   (OPCTRL(2))
//#define POWER_LED_ON_VAL                 (1)
//#define BACKUP_LED_GPIO                  (OPCTRL(0))
//#define BACKUP_LED_ON_VAL                (0)
// #define POWER_CTRL_GPIO
// #define POWER_CTRL_ON_VAL
#define DEFAULT_DEMOD_RESET_GPIO            (GPIO(57)) //PAD_DEMOD_RST in pinmux table
#define DEFAULT_DEMOD_I2C_BUS_ID  1
#define DEFAULT_TUNER_I2C_BUS_ID 1

//config PDWNC BUS0/1
#define SIF_ENABLE_PDWNC_MASTER      (1)
#define SIF_ENABLE_PDWNC_MASTER1      (1)

//----------------------------------------------------------------------------
// EEPROM customization
//----------------------------------------------------------------------------
#define SYSTEM_EEPROM_SIZE                  (65536) //64KBytes
//#define SYSTEM_EEPROM_WP_GPIO               (GPIO(83)) // OPWM0
//#define SYSTEM_EEPROM_WP_ENABLE_POLARITY    (1)
//#define EDID_EEPROM_WP_GPIO               (GPIO(4))   // GPIO14.
//#define EDID_EEPROM_WP_ENABLE_POLARITY    (1)
#ifdef CC_HOTKEY_WAKEUP_SUPPORT
#define SUPPORT_HOTKEY_WAKEUP				(1)
#endif

//----------------------------------------------------------------------------
// USB Customization
//----------------------------------------------------------------------------
// "USBx_PORT_USING_LOADER & USBx_PORT_USING" related define is only for USB2.0 port
// 1. Loader, USB port using define (1)=used (0)=not used
#define USB0_PORT_USING_LOADER              (1)
#define USB1_PORT_USING_LOADER              (1)
#define USB2_PORT_USING_LOADER              (0)
#define USB3_PORT_USING_LOADER              (1)

// 2. Nuclues/Linux/Android System USB port using define (1)=used (0)=not used
#define USB0_PORT_USING                     (1)
#define USB1_PORT_USING                     (1) 
#define USB2_PORT_USING                     (0) 
#define USB3_PORT_USING                     (1)

// 3. USB +5V power switch Vbus GPIO control, if vbus not control by GPIO, mark off it.
#define USB0_VBUS_GPIO   (77)//TCON11
#define USB0_VBUS_GPIO_POLARITY             (1)

#define USB0_OC_GPIO                        GPIO(44)//GPIO44
#define USB0_OC_GPIO_POLARITY               (0)

//#define USB2_VBUS_GPIO                      GPIO(46)
//#define USB2_VBUS_GPIO_POLARITY		        (1)
//#define USB3_VBUS_GPIO                      GPIO(47)
//#define USB3_VBUS_GPIO_POLARITY		        (1)

// 4. USB power switch overcurrent GPIO control, if have not ic to control by GPIO, mark off it.
#define USB1_VBUS_GPIO   (46)//GPIO46
#define USB1_VBUS_GPIO_POLARITY             (1)
#ifdef CC_SUPPORT_USB_OC // Only Sony 2K16 CVT2/MVT support
#define USB1_OC_GPIO                        (45)//GPIO45
#define USB1_OC_GPIO_POLARITY               (0)
#endif

//#define USB2_OC_GPIO                        ADIN(5)     // ADIN 5.
//#define USB2_OC_GPIO_POLARITY		        (0)
//#define USB3_OC_GPIO                        ADIN(5)     // ADIN 5.
//#define USB3_OC_GPIO_POLARITY		        (0)

// 5. Detect USB upgrade time, default is 0, but some device maybe can't detect when upgrade.
// If possible, set it to (300)ms when in customer's module.
#define USB_LOADER_WAIT_TIME                (300)

//#define USB_DISABLE_SUSPEND_MODE /* Disable USB suspend, share 240 Mhz with H.264.*/
//HUB_RESET
//#define USB_HUB_RESET_GPIO (GPIO(45))//PIN_GPIO45
//#define USB_HUB_RESET_GPIO_POLARITY (0)//L:RESET H:NORMAL

//----------------------------------------------------------------------------
// sdcard gpio define
//----------------------------------------------------------------------------
//#define MSDC_WP_GPIO                        (0)
//#define MSDC_POWER_GPIO                     (0)
//#define MSDC_DETECT_GPIO                    GPIO(231) //ADIN7
//#define MSDC_VOLTAGE_GPIO                   GPIO(43) //SDIO_PWR_CTRL
//----------------------------------------------------------------------------
// Button Customization
//----------------------------------------------------------------------------
#define FLAG_BUTTON_SUPPORT                 (1)
#define BUTTON_INCLUDE_FILE                 "Sony/Sony_button.h"

#ifndef T8032UP_INCLUDE_FILE
#define T8032UP_INCLUDE_FILE                "Sony/Sony_t8032fw.h"
#define T8032UP_OFFSET                      au1T8032FW
#define T8032UP_SIZE                        T8032FW_SIZE
#endif

//----------------------------------------------------------------------------
// MTK IR only setting
//----------------------------------------------------------------------------
#define IR_INCLUDE_FILE                     "Sony/sirc_ir.h"

#ifndef NPTV_SOURCE_TABLE
#define NPTV_SOURCE_TABLE                   "Sony/Sony_source_table.c"
#endif

//----------------------------------------------------------------------------
// default PIN Setup
//----------------------------------------------------------------------------
#define PINMUX_INCLUDE_FILE                 "Sony/Sony_pin_setup.h"
#define GPIO_INCLUDE_FILE                       "Sony/Sony_gpio.h"

//----------------------------------------------------------------------------
// default HDMI GPIO control
//----------------------------------------------------------------------------
#ifndef HDMI_GPIO_CONF
#define HDMI_GPIO_CONF                      "Sony/Sony_hdmi_conf.c"
#endif
#define HDMI_INCLUDE_FILE                "Sony/Sony_hdmi.h"

#define EDID_INCLUDE_FILE                "Sony/Sony_edid.h"

/*
 * default VGA table
*/
#ifndef VGA_INCLUDE_FILE
#define VGA_INCLUDE_FILE                    "Sony/Sony_vga.h"
#endif

//----------------------------------------------------------------------------
// Tcon Customization
//----------------------------------------------------------------------------
// support LVDS and MLVDS both
#define PANEL_DISPLAY_TYPE_ALLOWED_MASK ((1<<PANEL_DISPLAY_TYPE_LVDS) | (1 << PANEL_DISPLAY_TYPE_MLVDS) | (1 << PANEL_DISPLAY_TYPE_EPI) | (1 << PANEL_DISPLAY_TYPE_VB1))

#ifndef TCON_CUST_FILE
#define TCON_CUST_FILE                      "mtk/Capri_tcon_cust.c"
#endif
//#define SUPPORT_LOCK_FROM_SRVAD 

//----------------------------------------------------------------------------
// SCART out configuration
//----------------------------------------------------------------------------
#ifndef TVE_INCLUDE_FILE
#define TVE_INCLUDE_FILE                    "mtk/mtk_tve.c"
#endif

//----------------------------------------------------------------------------
// DMX configuration
//----------------------------------------------------------------------------
#ifndef DMX_INCLUDE_FILE
#define DMX_INCLUDE_FILE                    "Sony/Sony_dmx.h"
#endif

//----------------------------------------------------------------------------
// PCIE configuration
//----------------------------------------------------------------------------
//#define PCIE_RESET_GPIO                     GPIO(47) // OPCTRL4

//----------------------------------------------------------------------------
// Loader configuration
//----------------------------------------------------------------------------
#ifdef CC_EMMC_BOOT
#define MAX_UPGRADE_IMAGE_FILE_SIZE         (2*1024*1024*1024)     /* 512 MB */
#else
#ifdef CC_USE_256MB_NAND
#define MAX_UPGRADE_IMAGE_FILE_SIZE         (256*1024*1024)     /* 256 MB */
#else
#define MAX_UPGRADE_IMAGE_FILE_SIZE         (512*1024*1024)     /* 512 MB */
#endif
#endif
#if defined(LINUX_TURNKEY_SOLUTION) || defined(__KERNEL__)
//----------------------------------------------------------------------------
// Flash Partition configuration
//----------------------------------------------------------------------------
#ifdef CC_EMMC_BOOT
#define NAND_INCLUDE_FILE                   "Sony/sony_emmc_flash_layout.h"
#else
#define NAND_INCLUDE_FILE                   "Sony/sony_flash_layout.h"
#endif
#endif //defined(LINUX_TURNKEY_SOLUTION) || defined(__KERNEL__)

#if defined(LINUX_TURNKEY_SOLUTION) || defined(__KERNEL__)
#ifdef CC_FBM_MAPPING_ONE_BY_ONE
#ifndef FBM_BOOT_MMAP_INCLUDE_FILE
#define FBM_BOOT_MMAP_INCLUDE_FILE           "mtk/mtk_fbm_mmap.h"
#endif
#endif
#endif

/*
 * default quality table
*/
#ifndef QTYTBL_INCLUDE_FILE
//#define QTYTBL_INCLUDE_FILE               "mtk/QTY_DEFAULT/mtk_QtyTbl.h"
#endif

/*
 * dynamic backlight parameter
*/

/*
 * OD setting
*/

#define SUPPORT_OD                          (0)

/*
 *  ENABLE WOW for WiFi
*/
#ifdef WIFI_WOWLAN_SUPPORT
#define WAKEUP_ON_WLAN_GPIO 	OPCTRL(11)//PIN_OPCTRL11
#define WIFI_MODULE_RESET_GPIO 	GPIO(235)//PIN_VGA_SDA
#define WAKEUP_ON_WLAN_POL (0) //LOW:wakeup
#define WIFI_MODULE_RESET_GPIO_POL (0)//Low is reset
#define WIFI_MODULE_RESET_DURATION  (2000)//ms
#endif

#ifdef CC_PANEL_FROM_FLASH
#ifndef LOAD_PANEL_FROM_FLASH_CUSTOM
#define LOAD_PANEL_FROM_FLASH_CUSTOM            CustomPanelLoadTableFromFlash
#define DUMP_PANEL_LIST_FROM_FLASH_CUSTOM       CustomDumpPanelListFromFlash
#define CUSTOM_SHOW_PANEL_INFO_BY_ID(u4Idx)     CustomShowPanelInfoByID(u4Idx)

#define PANEL_VERSION_LENGTH                    16
#endif
#endif  /* CC_PANEL_FROM_FLASH */

#define PDWNC_EXT_IMPL                          "Sony/Sony_pdwnc.h"

#define CUSTOM_BACKLIGHT_DRV_BODY_FILE          "Sony/video_drv/Sony_backlight_drv.c"

#define CUSTOM_VIDEO_DRV_BODY_FILE              "Sony/video_drv/Sony_video_drv.c"

//for support both 3key and 4key front panel key wakeup
#define KEYPAD_WAKEUP_BIT           (DKBIT_POWER | DKBIT_CENTER)

//----------------------------------------------------------------------------
// D-interface Customization
//----------------------------------------------------------------------------
#ifndef DRV_CUSTOM_CUST_FILE
#define DRV_CUSTOM_CUST_FILE                    "Sony/Soem_linux_d_custom.c"
#endif

#ifndef DRV_CUSTOM_CUST_SPEC_SET
#define DRV_CUSTOM_CUST_SPEC_SET                d_Soem_cust_spec_set
#endif

#ifndef DRV_CUSTOM_CUST_SPEC_GET
#define DRV_CUSTOM_CUST_SPEC_GET                d_Soem_cust_spec_get
#endif

#endif
/*============END(Sony/Sony_common_pcb_drv_cust.h)===========*/
//----------------------------------------------------------------------------
// FBM setup
//----------------------------------------------------------------------------

#if 1
#define CC_CONFIG_OSD_CM_SIZE               (4) // 4:argb 8888 ;2:argb 4444
#define CC_CONFIG_OSD_BUF_MODE              (2) // 2:double  buffer ;1:sngle buffer
        
#ifndef CC_CONFIG_OSD_PLANE1_MAX_W
#define CC_CONFIG_OSD_PLANE1_MAX_W          (1280)
#endif
#ifndef CC_CONFIG_OSD_PLANE1_MAX_H
#define CC_CONFIG_OSD_PLANE1_MAX_H          (720)
#endif
#define CC_CONFIG_OSD_PLANE1_MEM_SIZE       (((CC_CONFIG_OSD_PLANE1_MAX_W*     \
                                        CC_CONFIG_OSD_PLANE1_MAX_H*        \
                                        CC_CONFIG_OSD_CM_SIZE*             \
                                        CC_CONFIG_OSD_BUF_MODE)+0x1000)&(0xFFFFF000))
        
        // osd 3d buffer size
#if (defined(CC_CONFIG_OSD_SBS_PLANE1)||defined(CC_CONFIG_OSD_TB_PLANE1))
#define CC_CONFIG_OSD_3D_PLANE1_MEM_SIZE    (CC_CONFIG_OSD_PLANE1_MEM_SIZE)
#else
#define CC_CONFIG_OSD_3D_PLANE1_MEM_SIZE    (0)
#endif
        
        // osd decompress  buffer size
#ifdef CONFIG_OSD_PLANE1_COMPRESSION
#define CC_CONFIG_OSD_DEC_PLANE1_MEM_SIZE   (CC_CONFIG_OSD_PLANE1_MEM_SIZE)
#else
#define CC_CONFIG_OSD_DEC_PLANE1_MEM_SIZE   (0)
#endif
        
#ifndef CC_CONFIG_OSD_PLANE2_MAX_W
#define CC_CONFIG_OSD_PLANE2_MAX_W          (960)
#endif
#ifndef CC_CONFIG_OSD_PLANE2_MAX_H
#define CC_CONFIG_OSD_PLANE2_MAX_H          (540)
#endif
#define CC_CONFIG_OSD_PLANE2_MEM_SIZE       (((CC_CONFIG_OSD_PLANE2_MAX_W*     \
                                            CC_CONFIG_OSD_PLANE2_MAX_H*        \
                                            CC_CONFIG_OSD_CM_SIZE*             \
                                            CC_CONFIG_OSD_BUF_MODE)+0x1000)&(0xFFFFF000))
        
#if (defined(CC_CONFIG_OSD_SBS_PLANE2)||defined(CC_CONFIG_OSD_TB_PLANE2))
#define CC_CONFIG_OSD_3D_PLANE2_MEM_SIZE    (CC_CONFIG_OSD_PLANE2_MEM_SIZE)
#else
#define CC_CONFIG_OSD_3D_PLANE2_MEM_SIZE    (0)
#endif
        
#ifndef CONFIG_OSD_PLANE2_COMPRESSION
        //#define  CONFIG_OSD_PLANE2_COMPRESSION
#endif
        
        // osd decompress  buffer size
#ifdef CONFIG_OSD_PLANE2_COMPRESSION
#define CC_CONFIG_OSD_DEC_PLANE2_MEM_SIZE   (CC_CONFIG_OSD_PLANE2_MEM_SIZE)
#else
#define CC_CONFIG_OSD_DEC_PLANE2_MEM_SIZE   (0)
#endif
        
#ifndef CC_CONFIG_OSD_PLANE3_MAX_W
#define CC_CONFIG_OSD_PLANE3_MAX_W          (1920)
#endif
#ifndef CC_CONFIG_OSD_PLANE3_MAX_H
#define CC_CONFIG_OSD_PLANE3_MAX_H          (1080)
#endif
#define CC_CONFIG_OSD_PLANE3_MEM_SIZE       (((CC_CONFIG_OSD_PLANE3_MAX_W*     \
                                            CC_CONFIG_OSD_PLANE3_MAX_H*        \
                                            CC_CONFIG_OSD_CM_SIZE*             \
                                            CC_CONFIG_OSD_BUF_MODE)+0x1000)&(0xFFFFF000))
        
#if (defined(CC_CONFIG_OSD_SBS_PLANE3)||defined(CC_CONFIG_OSD_TB_PLANE3))
#define CC_CONFIG_OSD_3D_PLANE3_MEM_SIZE    (CC_CONFIG_OSD_PLANE3_MEM_SIZE)
#else
#define CC_CONFIG_OSD_3D_PLANE3_MEM_SIZE    (0)
#endif
        
        // osd decompress  buffer size
#ifndef CONFIG_OSD_PLANE3_COMPRESSION
        // #define  CONFIG_OSD_PLANE3_COMPRESSION
#endif
        
#ifdef CONFIG_OSD_PLANE3_COMPRESSION
#define CC_CONFIG_OSD_DEC_PLANE3_MEM_SIZE   (CC_CONFIG_OSD_PLANE3_MEM_SIZE)
#else
#define CC_CONFIG_OSD_DEC_PLANE3_MEM_SIZE   (0)
#endif
        
#ifndef CC_CONFIG_OSD_PLANE4_MAX_W
#define CC_CONFIG_OSD_PLANE4_MAX_W          (0)
#endif
#ifndef CC_CONFIG_OSD_PLANE4_MAX_H
#define CC_CONFIG_OSD_PLANE4_MAX_H          (0)
#endif
#define CC_CONFIG_OSD_PLANE4_MEM_SIZE       (((CC_CONFIG_OSD_PLANE4_MAX_W*     \
                                            CC_CONFIG_OSD_PLANE4_MAX_H*        \
                                            CC_CONFIG_OSD_CM_SIZE*             \
                                            CC_CONFIG_OSD_BUF_MODE)+0x1000)&(0xFFFFF000))
        
#if (defined(CC_CONFIG_OSD_SBS_PLANE4)||defined(CC_CONFIG_OSD_TB_PLANE4))
#define CC_CONFIG_OSD_3D_PLANE4_MEM_SIZE    (CC_CONFIG_OSD_PLANE4_MEM_SIZE)
#else
#define CC_CONFIG_OSD_3D_PLANE4_MEM_SIZE    (0)
#endif
        
        // osd decompress  buffer size
#ifdef CONFIG_OSD_PLANE4_COMPRESSION
#define CC_CONFIG_OSD_DEC_PLANE4_MEM_SIZE   (CC_CONFIG_OSD_PLANE4_MEM_SIZE)
#else
#define CC_CONFIG_OSD_DEC_PLANE4_MEM_SIZE   (0)
#endif
        
#ifndef CC_CONFIG_OSD_PLANE5_MAX_W
#define CC_CONFIG_OSD_PLANE5_MAX_W          (100)
#endif
#ifndef CC_CONFIG_OSD_PLANE5_MAX_H
#define CC_CONFIG_OSD_PLANE5_MAX_H          (100)
#endif
        
#define CC_CONFIG_OSD_PLANE5_MEM_SIZE       (((CC_CONFIG_OSD_PLANE5_MAX_W*     \
                                    CC_CONFIG_OSD_PLANE5_MAX_H*        \
                                    CC_CONFIG_OSD_CM_SIZE)+0x1000)&(0xFFFFF000))
        
        // osd 3d buffer size
#if (defined(CC_CONFIG_OSD_SBS_PLANE5)||defined(CC_CONFIG_OSD_TB_PLANE5))
#define CC_CONFIG_OSD_3D_PLANE5_MEM_SIZE    (CC_CONFIG_OSD_PLANE5_MEM_SIZE)
#else
#define CC_CONFIG_OSD_3D_PLANE5_MEM_SIZE    (0)
#endif
        
        // osd decompress  buffer size
#ifdef CONFIG_OSD_PLANE5_COMPRESSION
#define CC_CONFIG_OSD_DEC_PLANE5_MEM_SIZE   (CC_CONFIG_OSD_PLANE5_MEM_SIZE)
#else
#define CC_CONFIG_OSD_DEC_PLANE5_MEM_SIZE   (0)
#endif
        
#define CC_CONFIG_OSD_PLANE_BASIC_MEM_SIZE  (CC_CONFIG_OSD_PLANE1_MEM_SIZE+ \
                                        CC_CONFIG_OSD_PLANE2_MEM_SIZE+  \
                                        CC_CONFIG_OSD_PLANE3_MEM_SIZE+  \
                                        CC_CONFIG_OSD_PLANE4_MEM_SIZE+  \
                                        CC_CONFIG_OSD_PLANE5_MEM_SIZE)
        
#define CC_CONFIG_OSD_3D_PLANE_MEM_SIZE     (CC_CONFIG_OSD_3D_PLANE1_MEM_SIZE+  \
                                            CC_CONFIG_OSD_3D_PLANE2_MEM_SIZE+   \
                                            CC_CONFIG_OSD_3D_PLANE3_MEM_SIZE+   \
                                            CC_CONFIG_OSD_3D_PLANE4_MEM_SIZE+   \
                                            CC_CONFIG_OSD_3D_PLANE5_MEM_SIZE)
        
#define CC_CONFIG_OSD_DEC_PLANE_MEM_SIZE    (CC_CONFIG_OSD_DEC_PLANE1_MEM_SIZE+ \
                                            CC_CONFIG_OSD_DEC_PLANE2_MEM_SIZE+  \
                                            CC_CONFIG_OSD_DEC_PLANE3_MEM_SIZE+  \
                                            CC_CONFIG_OSD_DEC_PLANE4_MEM_SIZE+  \
                                            CC_CONFIG_OSD_DEC_PLANE5_MEM_SIZE)
        
#define CC_CONFIG_GFX_TEMP_MEM_SIZE         (CC_CONFIG_OSD_PLANE3_MAX_W*    \
                                            CC_CONFIG_OSD_PLANE3_MAX_H*     \
                                            CC_CONFIG_OSD_CM_SIZE)
       

#ifdef CC_LINUX_GPU_SUPPORT
#define LINUX_GPU_BUFFER_SIZE            (8 * 1024 * 1028)
#else
#define LINUX_GPU_BUFFER_SIZE            (0)
#endif

#define DFB_SUM_MEM_SIZE                  (CC_CONFIG_OSD_PLANE_BASIC_MEM_SIZE+\
                                            CC_CONFIG_OSD_3D_PLANE_MEM_SIZE+    \
                                            CC_CONFIG_OSD_DEC_PLANE_MEM_SIZE+   \
                                            CC_CONFIG_GFX_TEMP_MEM_SIZE+        \
                                            LINUX_GPU_BUFFER_SIZE)

#endif                                                    

#ifdef CC_GFX_MMU
    #ifdef CC_FORCE_DRAM256M
        #define DIRECT_FB_MEM_SIZE	((DFB_SUM_MEM_SIZE+4*1024 + 150*1024)&(0xFFFFF000))	//add 150*1024 for fix jtv photo play issue by wwj 20160803, BTW previous issue log: failid(4147200)(4005888/20754432)
    #else
        #define DIRECT_FB_MEM_SIZE                  ((DFB_SUM_MEM_SIZE+4*1024 + 48*1024*1024)&(0xFFFFF000))  // IPTV GPU window using by Frank
    #endif
#else
#define DIRECT_FB_MEM_SIZE                  (76 * 1024 * 1024)
#endif



#define FB_MEM_SIZE                         (0)


#ifndef FBM_MEM_CFG_SIZE
#define FBM_MEM_CFG_SIZE                    (FBM_MEM_CFG_MT5882_3DTV)
//#define FBM_MEM_CFG_SIZE                FBM_MEM_CFG_MT5881_128Mx1
#endif /* FBM_MEM_CFG_SIZE */

#ifdef CC_TRUSTZONE_SUPPORT
#define TRUSTZONE_CODE_BASE                 (0x5000)
#if defined(CC_SVP_SUPPORT) && defined(CC_SUPPORT_4K2K)
        #define TRUSTZONE_MEM_SIZE                  ((8 * 1024 * 1024) + (40*1024*1024))
#else 
    #ifdef ANDROID
        #define TRUSTZONE_MEM_SIZE                  (18 * 1024 * 1024)
    #else
		#ifdef CC_FORCE_DRAM256M
			#define TRUSTZONE_MEM_SIZE                  (6 * 1024 * 1024)  //JTV Memory Shrink by Weiping.Xiao improve
		#else
			#define TRUSTZONE_MEM_SIZE                  (18 * 1024 * 1024)
		#endif
    #endif
#endif
#else
#define TRUSTZONE_MEM_SIZE                  (0)
#endif

#define LINUX_KERNEL_MEM_SIZE               ((TOTAL_MEM_SIZE > (FBM_MEM_CFG_SIZE + DIRECT_FB_MEM_SIZE + FB_MEM_SIZE + TRUSTZONE_MEM_SIZE)) ?\
                                            (TOTAL_MEM_SIZE - FBM_MEM_CFG_SIZE - DIRECT_FB_MEM_SIZE - FB_MEM_SIZE - TRUSTZONE_MEM_SIZE) : (54 * 1024 * 1024))

#define DEFAULT_TARGET_COUNTRY              (COUNTRY_PAD)  



//SCART_FS0
#define SCART1_FS_SERVO_ADC             (0)//SERVOAD_ADIN0


//----------------------------------------------------------------------------
// European CI (Common Interface) customization
//----------------------------------------------------------------------------
//#define CI_EXTERNAL_IC_INT_GPIO             (GPIO(84))  // Set:Interrupt Mode, UnSet:Polling Mode
#define CI_5V_OC_GPIO                       (GPIO(43))  //PIN_GPIO43
#define CI_5V_POWERON_GPIO                  (GPIO(42))
#define CI_5V_POWERON_POLARITY              (1)
#define CI_5V_OC_POLARITY                   (0) // CC_MT5882_TODO
#define CI_EXTERNAL_IC_DRIVING_CURRENT      (2)         // 2mA
#define CI_SYSTEM_CLOCK                     (72)        // 72 MHz
#define CI_TS_CLOCK                         (108)       // 108 MHz
#define CI_SPI_CLOCK                        (27)        // 72 MHz


/*
 * default color parameter
*/
#ifndef COLOR_PARAM_INCLUDE_FILE
//#define COLOR_PARAM_INCLUDE_FILE          "mtk/PANEL_DEFAULT/color_param.h"
#endif

#define QTYTBL_INCLUDE_FILE                 "Sony/QTY_Unicorn/Sony_QtyTbl.h"

#define COLOR_PARAM_INCLUDE_FILE                "Sony/PANEL_DEFAULT/color_param.h"


#define USB_UPGRADE_FILE_NAME_PREFIX    ("sony_fw_2017_")

#ifdef CC_IS_SIMPLE_IPTV
#define USB_UPGRADE_FILE_NAME           ("sony_fw_2017_0000_UCPAA.pkg")
#define USB_UPGRADE_FILE_NAME_SUFFIX    ("_UCPAA.pkg")
#else
#define USB_UPGRADE_FILE_NAME           ("sony_fw_2017_0000_UCPA1.pkg")
#define USB_UPGRADE_FILE_NAME_SUFFIX    ("_UCPA1.pkg")
#endif


#else /* CONFIG_DEFAULT_H */
#error "Cannot include multi-config files"
#endif /* CONFIG_DEFAULT_H */

#endif /* C_MODEL_H */
